###CONFIG###
# Automatically check for updates?
vm_checkforupdates = 1
###CONFIG###

import es, string, popuplib, playerlib, threading, urllib2, gamethread

votemod_ver = es.ServerVar("votemod_ver", 1.0, "The version of votemod you are running.")
votemod_ver.makepublic()

vm_mods = {}
vm_users = {}
vm_scriptlist = es.createscriptlist()
vm_file = open(es.getAddonPath("votemod") + "/mods.txt", "r")
for vm_line in vm_file:
    if not "#" in vm_line:
        vm_line = vm_line.rstrip()
        if not vm_line == "":
            vm_line = vm_line.split(' - ')
            vm_mods[vm_line[1]] = {}
            vm_mods[vm_line[1]][vm_line[0]] = {}
            if vm_line[1] in vm_scriptlist:
                vm_mods[vm_line[1]][vm_line[0]]["LOADED"] = 1
            else:
                vm_mods[vm_line[1]][vm_line[0]]["LOADED"] = 0
            vm_mods[vm_line[1]][vm_line[0]]["LISTED"] = 1
            vm_mods[vm_line[1]][vm_line[0]]["ACTIVATE_VOTES"] = 0
            vm_mods[vm_line[1]][vm_line[0]]["DEACTIVATE_VOTES"] = 0

vm_file = open(es.getAddonPath("votemod") + "/blacklist.txt", "r")
vm_blacklist = {}
for vm_line in vm_file:
    if not "#" in vm_line:
        vm_line = vm_line.rstrip()
        if not vm_line == "":
            vm_blacklist[vm_line] = 0

for vm_script in vm_scriptlist:
    if not "corelib" in vm_script:
        if not vm_script in vm_blacklist:
            vm_mods[vm_script] = {}
            vm_mods[vm_script][vm_script] = {}
            vm_mods[vm_script][vm_script]["LOADED"] = 1
            vm_mods[vm_script][vm_script]["LISTED"] = 1
            vm_mods[vm_script][vm_script]["ACTIVATE_VOTES"] = 0
            vm_mods[vm_script][vm_script]["DEACTIVATE_VOTES"] = 0

class CheckUpdates(threading.Thread):
    def run(self):
        vm_checkversion = urllib2.urlopen("http://impulse82.net/vm_version.txt").read()
        if votemod_ver < vm_checkversion:
            es.msg("#multi", "#green[VoteMod]#default This server is running an out-of-date version of #lightgreenVoteMod.")
        gamethread.delayedname(3600, "checkforupdate", checkstart)

def load():
    checkstart()
    for vm_userid in playerlib.getPlayerList('#all'):
        vm_steamid = es.getplayersteamid(int(vm_userid))
        if not vm_steamid in vm_users:
            vm_users[vm_steamid] = {}
            vm_users[vm_steamid]["ACTIVATE_VOTED"] = {}
            vm_users[vm_steamid]["DEACTIVATE_VOTED"] = {}

def unload():
    if vm_checkforupdates == 1:
        gamethread.cancelDelayed("checkforupdate")

def checkstart():
    if vm_checkforupdates == 1:
        CheckUpdates().start();

def player_activate(event_var):
    if not event_var["es_steamid"] in vm_users:
        vm_users[event_var["es_steamid"]] = {}
        vm_users[event_var["es_steamid"]]["ACTIVATE_VOTED"] = {}
        vm_users[event_var["es_steamid"]]["DEACTIVATE_VOTED"] = {}

def player_say(event_var):
    if event_var["text"] == "!votemod" or event_var["text"] == "!vm":
        sendpopup(event_var["userid"])

def round_start(event_var):
    es.msg("#multi", "#green[VoteMod] #defaultType #lightgreen!votemod #defaultto activate or deactivate mods!")

def sendpopup(vm_userid):
    if popuplib.isqueued('votemod', vm_userid):
        popuplib.close('votemod', vm_userid)
    votemod = popuplib.create("votemod")
    votemod.addline("-VoteMod v1.0-")
    votemod.addline("-------------------")
    votemod.addline("->1. Activate Mod")
    votemod.addline("->2. Deactivate Mod")
    votemod.addline("-------------------")
    votemod.addline("0. Close")
    votemod.select(1, activate_menu)
    votemod.select(2, deactivate_menu)
    votemod.send(vm_userid)

def activate_menu(vm_userid, vm_choice, vm_popup):
    global vm_mods
    votemod_activate = popuplib.easymenu('votemod_activate', '_popup_choice', activate_voted) 
    votemod_activate.settitle('-VoteMod v1.0-')
    for vm_modname in vm_mods:
        for vm_modshowname in vm_mods[vm_modname]:
            vm_loaded = vm_mods[vm_modname][vm_modshowname]["LOADED"]
            vm_listed = vm_mods[vm_modname][vm_modshowname]["LISTED"]
            if vm_listed == 1 and vm_loaded == 0:
                vm_players = es.getplayercount()
                if vm_players > 0:
                    vm_votesneeded = float(vm_players)
                    vm_votesneeded = vm_votesneeded / 2
                    vm_votestotal = int("%.0f" % vm_votesneeded)
                    vm_votesneeded = vm_votestotal - vm_mods[vm_modname][vm_modshowname]["ACTIVATE_VOTES"]
                    votemod_activate.addoption(vm_modname, "%s (%s/%s)" % (vm_modshowname, str(vm_votesneeded), str(vm_votestotal)))
    votemod_activate.send(vm_userid)

def deactivate_menu(vm_userid, vm_choice, vm_popup):
    global vm_mods
    votemod_deactivate = popuplib.easymenu('votemod_deactivate', '_popup_choice', deactivate_voted) 
    votemod_deactivate.settitle('-VoteMod v1.0-')
    for vm_modname in vm_mods:
        for vm_modshowname in vm_mods[vm_modname]:
            vm_loaded = vm_mods[vm_modname][vm_modshowname]["LOADED"]
            vm_listed = vm_mods[vm_modname][vm_modshowname]["LISTED"]
            if vm_listed == 1 and vm_loaded == 1:
                vm_players = es.getplayercount()
                if vm_players > 0:
                    vm_votesneeded = float(vm_players)
                    vm_votesneeded = vm_votesneeded / 2
                    vm_votestotal = int("%.0f" % vm_votesneeded)
                    vm_votesneeded = vm_votestotal - vm_mods[vm_modname][vm_modshowname]["DEACTIVATE_VOTES"]
                    votemod_deactivate.addoption(vm_modname, "%s (%s/%s)" % (vm_modshowname, str(vm_votesneeded), str(vm_votestotal)))
    votemod_deactivate.send(vm_userid)

def activate_voted(vm_userid, vm_modname, vm_popup):
    vm_steamid = es.getplayersteamid(vm_userid)
    if not vm_modname in vm_users[vm_steamid]["ACTIVATE_VOTED"]:
        for vm_modshowname in vm_mods[vm_modname]:
            vm_mods[vm_modname][vm_modshowname]["ACTIVATE_VOTES"] += 1
        vm_steamid = es.getplayersteamid(vm_userid)
        vm_users[vm_steamid]["ACTIVATE_VOTED"][vm_modname] = 0
        vm_name = es.getplayername(vm_userid)
        vm_players = es.getplayercount()
        if vm_players > 0:
            vm_votesneeded = float(vm_players)
            vm_votesneeded = vm_votesneeded / 2
            vm_votesneeded = int("%.0f" % vm_votesneeded)
            vm_votesneeded -= vm_mods[vm_modname][vm_modshowname]["ACTIVATE_VOTES"]
        else:
            vm_votesneeded = 0
        if vm_votesneeded == 1:
            es.msg("#multi", "#green[VoteMod] #lightgreen%s #defaultvoted to activate #lightgreen%s#default, #lightgreen%i #defaultmore vote is needed." % (vm_name, vm_modshowname, int(vm_votesneeded)))
        else:
            es.msg("#multi", "#green[VoteMod] #lightgreen%s #defaultvoted to activate #lightgreen%s#default, #lightgreen%i #defaultmore votes are needed." % (vm_name, vm_modshowname, int(vm_votesneeded)))
        if vm_votesneeded == 0:
            es.reload(vm_modname)
            vm_mods[vm_modname][vm_modshowname]["ACTIVATE_VOTES"] = 0
            vm_mods[vm_modname][vm_modshowname]["LOADED"] = 1
            es.msg("#multi", "#green[VoteMod] #lightgreen%s #defaulthas been loaded!" % vm_modshowname)
    else:
        for vm_modshowname in vm_mods[vm_modname]:
            es.msg("#multi", "#green[VoteMod] #defaultYou have already voted to activate #lightgreen%s#default." % vm_modshowname)

def deactivate_voted(vm_userid, vm_modname, vm_popup):
    vm_steamid = es.getplayersteamid(vm_userid)
    if not vm_modname in vm_users[vm_steamid]["DEACTIVATE_VOTED"]:
        for vm_modshowname in vm_mods[vm_modname]:
            vm_mods[vm_modname][vm_modshowname]["DEACTIVATE_VOTES"] += 1
        vm_steamid = es.getplayersteamid(vm_userid)
        vm_users[vm_steamid]["DEACTIVATE_VOTED"][vm_modname] = 0
        vm_name = es.getplayername(vm_userid)
        vm_players = es.getplayercount()
        if vm_players > 0:
            vm_votesneeded = float(vm_players)
            vm_votesneeded = vm_votesneeded / 2
            vm_votesneeded = int("%.0f" % vm_votesneeded)
            vm_votesneeded -= vm_mods[vm_modname][vm_modshowname]["DEACTIVATE_VOTES"]
        else:
            vm_votesneeded = 0
        if vm_votesneeded == 1:
            es.msg("#multi", "#green[VoteMod] #lightgreen%s #defaultvoted to deactivate #lightgreen%s#default, #lightgreen%i #defaultmore vote is needed." % (vm_name, vm_modshowname, int(vm_votesneeded)))
        else:
            es.msg("#multi", "#green[VoteMod] #lightgreen%s #defaultvoted to deactivate #lightgreen%s#default, #lightgreen%i #defaultmore votes are needed." % (vm_name, vm_modshowname, int(vm_votesneeded)))
        if vm_votesneeded == 0:
            es.unload(vm_modname)
            vm_mods[vm_modname][vm_modshowname]["DEACTIVATE_VOTES"] = 0
            vm_mods[vm_modname][vm_modshowname]["LOADED"] = 0
            es.msg("#multi", "#green[VoteMod] #lightgreen%s #defaulthas been unloaded!" % vm_modshowname)
    else:
        for vm_modshowname in vm_mods[vm_modname]:
            es.msg("#multi", "#green[VoteMod] #defaultYou have already voted to deactivate #lightgreen%s#default." % vm_modshowname)